#!/bin/sh

set -e

cd $(dirname $0)

. ../../common/config.sh
. ../../common/log.sh

log_start "$0" "usermod tests if the new user's UID is already used"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config' 0

change_config

echo add group tr
groupadd tr
echo add group rtr
groupadd rtr
echo add user tr to group tr
useradd -g tr tr
echo rename group rtr to tr in /etc/gshadow
perl -pi -e 's/rtr/tr/g' /etc/gshadow
echo add user tr to the member list of tr
usermod -G tr tr 2>tmp/usermod.err && exit 1 || {
	status=$?
}
echo "OK"

echo -n "Check returned status ($status)..."
test "$status" = "10"
echo "OK"

echo "usermod reported:"
echo "======================================================================="
cat tmp/usermod.err
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au data/usermod.err tmp/usermod.err
echo "error message OK."
rm -f tmp/usermod.err

echo -n "Check the passwd file..."
../../common/compare_file.pl data/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../common/compare_file.pl data/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../common/compare_file.pl data/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
../../common/compare_file.pl data/gshadow /etc/gshadow
echo "OK"

log_status "$0" "SUCCESS"
restore_config
trap '' 0

